//+------------------------------------------------------------------+
//|                                    Trade_Asst_RiskManagement.mq4 |
//|                                                            Gypsy |
//|                                                   www.Google.com |
//+------------------------------------------------------------------+
#property copyright "Gypsy"
#property link      "www.Google.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
/*-------------------------------------------------------------------------------------------------*/
color  FontColor=clrDarkGray;
int    FontSize=9;
string FontType="Courier New";
/*-------------------------------------------------------------------------------------------------*/
//Moving Average Indicator
/*-------------------------------------------------------------------------------------------------*/
//Fast Moving Average
extern string Fast_MASettings="Fast Moving Average";//Alert
extern int    Fast_MAperiod=21;//Fast MA Period
extern int    Fast_MAindshift=0;//Fast MA Indicator Shift
extern string Choose_FastMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Fast MA
extern int    Fast_MAcalcMethod=1;//Fast MA Calculation Method 
extern string Choose_FastMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Fast_MAappliedprice=0;//Fast MA Applied Price
extern int    Fast_MAbufferShift=1;//Fast MA Buffer Shift
extern string Fast_break="";//=======================================

double FastMA=0;
/*-------------------------------------------------------------------------------------------------*/
//Slow Moving Average
extern string Slow_MASettings="Slow Moving Average";//Alert
extern int    Slow_MAperiod=50;//Slow MA Period
extern int    Slow_MAindshift=0;//Slow MA Indicator Shift
extern string Choose_SlowMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Slow MA
extern int    Slow_MAcalcMethod=1;//Slow MA Calculation Method 
extern string Choose_SlowMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Slow_MAappliedprice=0;//Slow MA Applied Price
extern int    Slow_MAbufferShift=1;//Slow MA Buffer Shift
extern string Slow_break="";//=======================================

double SlowMA=0;
/*-------------------------------------------------------------------------------------------------*/
//Trend Moving Average
extern string Trend_MASettings="Trend Moving Average";//Alert
extern int    Trend_MAperiod=200;//Trend MA Period
extern int    Trend_MAindshift=0;//Trend MA Indicator Shift
extern string Choose_TrendMA_CalcMethod="0=Simple,1=Exponential,2=Smoothed,3=Linear Weighted";//Choose the Calculation Method for the Trend MA
extern int    Trend_MAcalcMethod=0;//Trend MA Calculation Method 
extern string Choose_TrendMA_AppliedPrice="0=Close,1=Open,2=High,3=Low,4=Median Price,5=Typical Price,6=Weighted Close";
extern int    Trend_MAappliedprice=0;//Trend MA Applied Price
extern int    Trend_MAbufferShift=1;//Trend MA  Buffer Shift
extern string Trend_break="";//=======================================

double TrendMA=0;
/*-------------------------------------------------------------------------------------------------*/
int i;
double Max_SL=0;

double FastMA_SL_Long=0;
double SlowMA_SL_Long=0;
double TrendMA_SL_Long=0;

double FastMA_SL_Short=0;
double SlowMA_SL_Short=0;
double TrendMA_SL_Short=0;

double Choose_SL[4];
double Calc=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*-------------------------------------------------------------------------------------------------*/
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
/*-------------------------------------------------------------------------------------------------*/
   double TickDigits=MarketInfo(Symbol(),MODE_TICKSIZE);
   if(TickDigits==0.00001 || TickDigits==0.0001)
      Calc=.0001;
   else Calc=.01;
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss_Placement Long
   if(ObjectFind(0,"RM_StopLoss_Placement_Long")<0)
     {
      ObjectCreate("RM_StopLoss_Placement_Long",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_Placement_Long",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_Placement_Long",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_Placement_Long",OBJPROP_YDISTANCE,20);
     }
//ObjectDelete("RM_StopLoss_Placement_Long");
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss_Placement Short
   if(ObjectFind(0,"RM_StopLoss_Placement_Short")<0)
     {
      ObjectCreate("RM_StopLoss_Placement_Short",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_Placement_Short",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_Placement_Short",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_Placement_Short",OBJPROP_YDISTANCE,40);
     }
//ObjectDelete("RM_StopLoss_Placement_Short");
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss
   if(ObjectFind(0,"RM_StopLoss_Max_Risk")<0)
     {
      ObjectCreate("RM_StopLoss_Max_Risk",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_Max_Risk",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_Max_Risk",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_Max_Risk",OBJPROP_YDISTANCE,80);
     }
//ObjectDelete("RM_StopLoss_Max_Risk");
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss_FastMA
   if(ObjectFind(0,"RM_StopLoss_FastMA")<0)
     {
      ObjectCreate("RM_StopLoss_FastMA",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_FastMA",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_FastMA",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_FastMA",OBJPROP_YDISTANCE,100);
     }
//ObjectDelete("RM_StopLoss_FastMA");
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss_SlowMA
   if(ObjectFind(0,"RM_StopLoss_SlowMA")<0)
     {
      ObjectCreate("RM_StopLoss_SlowMA",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_SlowMA",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_SlowMA",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_SlowMA",OBJPROP_YDISTANCE,120);
     }
//ObjectDelete("RM_StopLoss_SlowMA");
/*-------------------------------------------------------------------------------------------------*/
//RM_StopLoss_TrendMA
   if(ObjectFind(0,"RM_StopLoss_TrendMA")<0)
     {
      ObjectCreate("RM_StopLoss_TrendMA",OBJ_LABEL,0,0,0);
      ObjectSet("RM_StopLoss_TrendMA",OBJPROP_CORNER,1);
      ObjectSet("RM_StopLoss_TrendMA",OBJPROP_XDISTANCE,0);
      ObjectSet("RM_StopLoss_TrendMA",OBJPROP_YDISTANCE,140);
     }
//ObjectDelete("RM_StopLoss_TrendMA");
/*-------------------------------------------------------------------------------------------------*/
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Indicator Deinitialization Function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
/*-------------------------------------------------------------------------------------------------*/
   ObjectDelete("RM_StopLoss_Placement_Long");
   ObjectDelete("RM_StopLoss_Placement_Short");
   ObjectDelete("RM_StopLoss_Max_Risk");
   ObjectDelete("RM_StopLoss_FastMA");
   ObjectDelete("RM_StopLoss_SlowMA");
   ObjectDelete("RM_StopLoss_TrendMA");
/*-------------------------------------------------------------------------------------------------*/
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(IsNewCandle())
     {
      Risk_Management();
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Risk_Management()
  {
/*-------------------------------------------------------------------------------------------------*/
//Fast Moving Average
   FastMA=iMA(Symbol(),0,Fast_MAperiod,Fast_MAindshift,Fast_MAcalcMethod,Fast_MAappliedprice,Fast_MAbufferShift);
/*-------------------------------------------------------------------------------------------------*/
//Slow Moving Average
   SlowMA=iMA(Symbol(),0,Slow_MAperiod,Slow_MAindshift,Slow_MAcalcMethod,Slow_MAappliedprice,Slow_MAbufferShift);
/*-------------------------------------------------------------------------------------------------*/
//Trend Moving Average
   TrendMA=iMA(Symbol(),0,Trend_MAperiod,Trend_MAindshift,Trend_MAcalcMethod,Trend_MAappliedprice,Trend_MAbufferShift);
/*-------------------------------------------------------------------------------------------------*/
   if(Close[1]>Open[1])
     {
      Max_SL=NormalizeDouble(Ask-(100*Calc),Digits);
     }
   if(Close[1]<Open[1])
     {
      Max_SL=NormalizeDouble((100*Calc)+Bid,Digits);
     }
   ArrayFill(Choose_SL,0,1,Max_SL);
   ArrayFill(Choose_SL,1,1,FastMA);
   ArrayFill(Choose_SL,2,1,SlowMA);
   ArrayFill(Choose_SL,3,1,TrendMA);

   int Min=ArrayMinimum(Choose_SL,WHOLE_ARRAY,0);
   int Max=ArrayMaximum(Choose_SL,WHOLE_ARRAY,0);
/*-------------------------------------------------------------------------------------------------*/
   ObjectSetText("RM_StopLoss_Placement_Long",
                 "RM_StopLoss_Placement_Long   "+DoubleToStr(Choose_SL[Min],Digits),FontSize,FontType,FontColor);

   ObjectSetText("RM_StopLoss_Placement_Short",
                 "RM_StopLoss_Placement_Short   "+DoubleToStr(Choose_SL[Max],Digits),FontSize,FontType,FontColor);

   ObjectSetText("RM_StopLoss_Max_Risk","StopLoss_Max_Risk   "+
                 DoubleToStr(Max_SL,Digits),FontSize,FontType,FontColor);

   ObjectSetText("RM_StopLoss_FastMA","RM_StopLoss_FastMA "+IntegerToString(Fast_MAperiod,Digits)+"  "+
                 DoubleToStr(FastMA,Digits),FontSize,FontType,FontColor);

   ObjectSetText("RM_StopLoss_SlowMA","RM_StopLoss_SlowMA   "+IntegerToString(Slow_MAperiod,Digits)+"  "+
                 DoubleToStr(SlowMA,Digits),FontSize,FontType,FontColor);

   ObjectSetText("RM_StopLoss_TrendMA","RM_StopLoss_TrendMA   "+IntegerToString(Trend_MAperiod,Digits)+"  "+
                 DoubleToStr(TrendMA,Digits),FontSize,FontType,FontColor);
/*-------------------------------------------------------------------------------------------------*/
//Error Control
   GetLastError();
  }
//+------------------------------------------------------------------+
//New Candle Check
//+------------------------------------------------------------------+
bool IsNewCandle()
  {
/*-------------------------------------------------------------------------------------------------*/
   static int BarsOnChart=0;
   if(Bars==BarsOnChart)
      return (false);
   BarsOnChart=Bars;
   return(true);
/*-------------------------------------------------------------------------------------------------*/
  }
//+------------------------------------------------------------------+
